Index: branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_IBP_3view.cfg
===================================================================
--- branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_IBP_3view.cfg	(revision 1373)
+++ branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_IBP_3view.cfg	(revision 1380)
@@ -15,5 +15,5 @@
 #======== VPS / Output layer sets ================
 DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
-OutputLayerSetIdx             : 1 2          # Indices of layer sets used to derive additional output layer sets
+OutputLayerSetIdx             : 2 2          # Indices of layer sets used to derive additional output layer sets
 LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
 LayerIdsInAddOutputLayerSet_1 : 2            # Indices in VPS of output layers in additional output layer set 1
@@ -29,5 +29,5 @@
 ProfileTierLevelIdx_1         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 1 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_2         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_3         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_3         : 1 2 -1                     # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_4         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
 
Index: branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_IPB_on_IRAP_3view.cfg
===================================================================
--- branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_IPB_on_IRAP_3view.cfg	(revision 1373)
+++ branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_IPB_on_IRAP_3view.cfg	(revision 1380)
@@ -5,10 +5,9 @@
 LayerIdsInSet_0               : 0            # Indices in VPS of layers in layer set 0
 LayerIdsInSet_1               : 0 1          # Indices in VPS of layers in layer set 1
-LayerIdsInSet_2               : 0 2          # Indices in VPS of layers in layer set 2
-LayerIdsInSet_3               : 0 1 2        # Indices in VPS of layers in layer set 3
+LayerIdsInSet_2               : 0 1 2        # Indices in VPS of layers in layer set 2
 
 #======== VPS / Output layer sets ================
 DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
-OutputLayerSetIdx             : 1 2          # Indices of layer sets used to derive additional output layer sets
+OutputLayerSetIdx             : 2 2          # Indices of layer sets used to derive additional output layer sets
 LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
 LayerIdsInAddOutputLayerSet_1 : 2            # Indices in VPS of output layers in additional output layer set 1
@@ -23,8 +22,7 @@
 ProfileTierLevelIdx_0         : 1                          # VpsProfileTierLevel indices of layers in output layer set 0 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_1         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 1 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_2         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_3         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_4         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 4 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_5         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 5 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_3         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_4         : 1 2 -1                     # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_5         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 4 (m) (should be -1, when layer is not necessary)
 
 
Index: branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_PIP_on_IRAP_3view.cfg
===================================================================
--- branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_PIP_on_IRAP_3view.cfg	(revision 1373)
+++ branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/gopCfg_PIP_on_IRAP_3view.cfg	(revision 1380)
@@ -10,5 +10,5 @@
 #======== VPS / Output layer sets ================
 DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
-OutputLayerSetIdx             : 1 2          # Indices of layer sets used to derive additional output layer sets
+OutputLayerSetIdx             : 3 3          # Indices of layer sets used to derive additional output layer sets
 LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
 LayerIdsInAddOutputLayerSet_1 : 2            # Indices in VPS of output layers in additional output layer set 1
@@ -25,6 +25,6 @@
 ProfileTierLevelIdx_2         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_3         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_4         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 4 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_5         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 5 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_4         : 1 2 -1                     # VpsProfileTierLevel indices of layers in output layer set 4 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_5         : 1 -1 2                     # VpsProfileTierLevel indices of layers in output layer set 5 (m) (should be -1, when layer is not necessary)
 
 
Index: branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/layerwise_startup_IBP_3view.cfg
===================================================================
--- branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/layerwise_startup_IBP_3view.cfg	(revision 1373)
+++ branches/HTM-15.2-dev/cfg/MV-HEVC/NonCTC/layerwise_startup_IBP_3view.cfg	(revision 1380)
@@ -15,5 +15,5 @@
 #======== VPS / Output layer sets ================
 DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
-OutputLayerSetIdx             : 1 2          # Indices of layer sets used to derive additional output layer sets
+OutputLayerSetIdx             : 2 2          # Indices of layer sets used to derive additional output layer sets
 LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
 LayerIdsInAddOutputLayerSet_1 : 2            # Indices in VPS of output layers in additional output layer set 1
@@ -35,5 +35,5 @@
 ProfileTierLevelIdx_1         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 1 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_2         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_3         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_3         : 1 2 -1                     # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_4         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
 
Index: branches/HTM-15.2-dev/cfg/MV-HEVC/baseCfg_2view.cfg
===================================================================
--- branches/HTM-15.2-dev/cfg/MV-HEVC/baseCfg_2view.cfg	(revision 1373)
+++ branches/HTM-15.2-dev/cfg/MV-HEVC/baseCfg_2view.cfg	(revision 1380)
@@ -31,7 +31,4 @@
 DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
 
-OutputLayerSetIdx             : 1            # Indices of layer sets used to derive additional output layer sets
-LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
-
 #======== VPS / PTLI ================
 Profile                       : main main multiview-main   # Profile indication in VpsProfileTierLevel, per VpsProfileTierLevel syntax structure  (m) 
@@ -42,5 +39,4 @@
 ProfileTierLevelIdx_0         : 1                          # VpsProfileTierLevel indices of layers in output layer set 0 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_1         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 1 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_2         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
 
 #======== VPS / Dependencies ================
Index: branches/HTM-15.2-dev/cfg/MV-HEVC/baseCfg_3view.cfg
===================================================================
--- branches/HTM-15.2-dev/cfg/MV-HEVC/baseCfg_3view.cfg	(revision 1373)
+++ branches/HTM-15.2-dev/cfg/MV-HEVC/baseCfg_3view.cfg	(revision 1380)
@@ -35,5 +35,5 @@
 DefaultTargetOutputLayerIdc   : 0            # Specifies output layers of layer sets, 0: output all layers, 1: output highest layer, 2: specified by LayerIdsInDefOutputLayerSet
 
-OutputLayerSetIdx             : 1 2          # Indices of layer sets used to derive additional output layer sets
+OutputLayerSetIdx             : 3 3          # Indices of layer sets used to derive additional output layer sets
 LayerIdsInAddOutputLayerSet_0 : 1            # Indices in VPS of output layers in additional output layer set 0
 LayerIdsInAddOutputLayerSet_1 : 2            # Indices in VPS of output layers in additional output layer set 1
@@ -49,6 +49,6 @@
 ProfileTierLevelIdx_2         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 2 (m) (should be -1, when layer is not necessary)
 ProfileTierLevelIdx_3         : 1 2 2                      # VpsProfileTierLevel indices of layers in output layer set 3 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_4         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 4 (m) (should be -1, when layer is not necessary)
-ProfileTierLevelIdx_5         : 1 2                        # VpsProfileTierLevel indices of layers in output layer set 5 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_4         : 1 2 -1                     # VpsProfileTierLevel indices of layers in output layer set 4 (m) (should be -1, when layer is not necessary)
+ProfileTierLevelIdx_5         : 1 -1 2                     # VpsProfileTierLevel indices of layers in output layer set 5 (m) (should be -1, when layer is not necessary)
 
 #======== VPS / Dependencies ================