Index: /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1391)
+++ /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1392)
@@ -5101,9 +5101,5 @@
 
   //// ******* Get disparity from left block ******* /////
-#if NH_3D_FIX_TICKET_91
-    pcTmpCU = getPULeft(uiIdx, uiPartIdxLB);
-#else
-  pcTmpCU = getPULeft(uiIdx, uiPartIdxLB, true, false);
-#endif
+  pcTmpCU = getPULeft(uiIdx, uiPartIdxLB);
   bCheckMcpDv = true; 
   if ( xCheckSpatialNBDV( pcTmpCU, uiIdx, pDInfo, bCheckMcpDv, &cIDVInfo, DVFROM_LEFT
Index: /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TComSlice.cpp	(revision 1391)
+++ /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TComSlice.cpp	(revision 1392)
@@ -1923,7 +1923,4 @@
   for ( Int i = 0; i < MAX_VPS_OUTPUTLAYER_SETS; i++)
   {
-#if !NH_3D_FIX_TICKET_107
-    m_layerSetIdxForOlsMinus1[i]  = -1; 
-#endif
     for ( Int j = 0; j < MAX_VPS_NUH_LAYER_ID_PLUS1; j++)
     {
Index: /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TypeDef.h	(revision 1391)
+++ /branches/HTM-16.0-dev1/source/Lib/TLibCommon/TypeDef.h	(revision 1392)
@@ -65,6 +65,6 @@
 #if NH_MV
 // Recent bug fixes
-#define NH_3D_FIX_TICKET_107                     1 // Clean up. 
-#define NH_3D_FIX_TICKET_91                      1 // NBDV availability in case of tiles.
+#define NH_3D_FIX_TICKET_114                     1  //Mismatch between text and software on DPB size syntax
+#define NH_3D_FIX_LEAK                           1
 // Things that needs to be fixed also in the Specification ...
 #define NH_MV_FIX_NO_REF_PICS_CHECK               1 // !!SPEC!!
Index: /branches/HTM-16.0-dev1/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/HTM-16.0-dev1/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1391)
+++ /branches/HTM-16.0-dev1/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 1392)
@@ -2135,5 +2135,9 @@
     for( Int j = 0; j  <=  vps->getMaxSubLayersInLayerSetMinus1( currLsIdx ); j++ )
     {  
+#if NH_3D_FIX_TICKET_114
+      if( j > 0  &&  dpbSize.getSubLayerFlagInfoPresentFlag( i )  )  
+#else
       if( j > 0  &&  dpbSize.getSubLayerDpbInfoPresentFlag( i, j )  )  
+#endif
       {
         READ_FLAG( uiCode, "sub_layer_dpb_info_present_flag" ); dpbSize.setSubLayerDpbInfoPresentFlag( i, j, uiCode == 1 );
Index: /branches/HTM-16.0-dev1/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- /branches/HTM-16.0-dev1/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1391)
+++ /branches/HTM-16.0-dev1/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1392)
@@ -1428,5 +1428,9 @@
     for( Int j = 0; j  <=  vps->getMaxSubLayersInLayerSetMinus1( currLsIdx ); j++ )
     {  
+#if NH_3D_FIX_TICKET_114
+      if( j > 0  &&  dpbSize->getSubLayerFlagInfoPresentFlag( i )  )  
+#else
       if( j > 0  &&  dpbSize->getSubLayerDpbInfoPresentFlag( i, j )  )  
+#endif
       {
         WRITE_FLAG( dpbSize->getSubLayerDpbInfoPresentFlag( i, j ) ? 1 : 0 , "sub_layer_dpb_info_present_flag" );
Index: /branches/HTM-16.0-dev1/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- /branches/HTM-16.0-dev1/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1391)
+++ /branches/HTM-16.0-dev1/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1392)
@@ -91,4 +91,18 @@
 TEncTop::~TEncTop()
 {
+#if NH_3D_FIX_LEAK
+#if NH_3D_IC
+  if ( m_aICEnableCandidate != NULL )
+  {
+    delete[] m_aICEnableCandidate;
+  }
+
+  if ( m_aICEnableNum != NULL )
+  {
+    delete[] m_aICEnableNum;
+  }
+#endif
+
+#endif
 #if ENC_DEC_TRACE
   if (g_hTrace != stdout)
Index: /branches/HTM-16.0-dev1/source/Lib/TLibRenderer/TRenModSetupStrParser.h
===================================================================
--- /branches/HTM-16.0-dev1/source/Lib/TLibRenderer/TRenModSetupStrParser.h	(revision 1391)
+++ /branches/HTM-16.0-dev1/source/Lib/TLibRenderer/TRenModSetupStrParser.h	(revision 1392)
@@ -40,7 +40,4 @@
 #include "../TAppCommon/TAppComCamPara.h"
 #if NH_3D_VSO
-
-
-
 #include <list>
 #include <vector>
@@ -54,5 +51,4 @@
 #include <cstdio>
 #include <cstring>
-
 
 using namespace std;