Index: branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1391)
+++ branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1394)
@@ -188,4 +188,6 @@
     free (  m_pchVSOConfig );
   }
+#endif
+#if NH_3D_VSO || NH_3D  
   
   if ( m_pchCameraParameterFile != NULL )
@@ -816,5 +818,5 @@
   ("ViewId",                         m_viewId                      , IntAry1d(1,0),                                 "View Id per View Order Index")
   ("AuxId",                          m_auxId                       , IntAry1d(1,0),                                 "AuxId per layer")
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   ("DepthFlag",                      m_depthFlag                   , IntAry1d(1,0),                                 "Depth Flag")
 #endif
@@ -1285,8 +1287,9 @@
   ("Depth420OutputFlag",                              m_depth420OutputFlag,           true                     , "Output depth layers in 4:2:0 ") 
 #endif
-#if NH_3D_VSO  
+#if NH_3D_VSO  || NH_3D
   ("CameraParameterFile,cpf",                         m_pchCameraParameterFile,    (TChar *) 0                 , "Camera Parameter File Name")
   ("CodedCamParsPrecision",                           m_iCodedCamParPrecision,      STD_CAM_PARAMETERS_PRECISION, "precision for coding of camera parameters (in units of 2^(-x) luma samples)" )
-
+#endif
+#if NH_3D_VSO  
   /* View Synthesis Optimization */
   ("VSOConfig",                                       m_pchVSOConfig            , (TChar *) 0                   ,"VSO configuration")
@@ -1807,5 +1810,5 @@
   xResizeVector( m_auxId );
 
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   xResizeVector( m_depthFlag ); 
 #endif
@@ -2070,6 +2073,7 @@
       LOG2_DISP_PREC_LUT );
   }
-#if NH_3D
   else
+#endif
+#if NH_3D || NH_3D_VSO
   {
     m_cCameraData     .init     ( ((UInt) m_iNumberOfViews ), 
@@ -2085,5 +2089,4 @@
   }
   m_cCameraData.check( false, true );
-#endif
 #endif
 
@@ -2270,5 +2273,5 @@
 #endif
 
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   if ( m_scalabilityMask & ( 1 << DEPTH_ID ) )
   {
@@ -2629,9 +2632,11 @@
   }
 
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   xConfirmPara( m_pchCameraParameterFile    == 0                ,   "CameraParameterFile must be given");
   xConfirmPara( m_pchBaseViewCameraNumbers  == 0                ,   "BaseViewCameraNumbers must be given" );
   xConfirmPara( m_iNumberOfViews != m_cCameraData.getBaseViewNumbers().size() ,   "Number of Views in BaseViewCameraNumbers must be equal to NumberOfViews" );
   xConfirmPara    ( m_iCodedCamParPrecision < 0 || m_iCodedCamParPrecision > 5,       "CodedCamParsPrecision must be in range of 0..5" );
+#endif
+#if NH_3D_VSO
     if( m_bUseVSO )
     {
@@ -3393,5 +3398,5 @@
   xPrintParaVector( "AuxId", m_auxId );
 #endif
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   xPrintParaVector( "DepthLayerFlag", m_depthFlag ); 
   printf("Coded Camera Param. Precision     : %d\n", m_iCodedCamParPrecision);  
@@ -3595,7 +3600,9 @@
 
   printf("Max Num Merge Candidates          : %d\n", m_maxNumMergeCand);
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   printf("BaseViewCameraNumbers             : %s\n", m_pchBaseViewCameraNumbers ); 
   printf("Coded Camera Param. Precision     : %d\n", m_iCodedCamParPrecision);
+#endif
+#if NH_3D_VSO
   printf("Force use of Lambda Scale         : %d\n", m_bForceLambdaScaleVSO );
 
Index: branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncCfg.h	(revision 1391)
+++ branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncCfg.h	(revision 1394)
@@ -80,5 +80,5 @@
   IntAry1d               m_viewOrderIndex;                    ///< view order index  
   IntAry1d               m_auxId;                             ///< auxiliary id
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   IntAry1d               m_depthFlag;                         ///< depth flag
 #endif
@@ -532,8 +532,10 @@
 #endif
     // Camera parameters
-#if NH_3D_VSO
+#if NH_3D || NH_3D_VSO
   TChar*    m_pchCameraParameterFile;                         ///< camera parameter file
   TAppComCamPara m_cCameraData;
   Int       m_iCodedCamParPrecision;                          ///< precision for coding of camera parameters
+#endif
+#if NH_3D_VSO
   TChar*    m_pchVSOConfig;
   Bool      m_bUseVSO;                                        ///< flag for using View Synthesis Optimization
Index: branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1391)
+++ branches/HTM-16.0-dev1/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1394)
@@ -148,5 +148,5 @@
   xSetCamPara              ( vps ); 
 #endif
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
   m_ivPicLists.setVPS      ( &vps );
 #endif
@@ -278,5 +278,5 @@
     m_cTEncTop.setViewId                       ( vps.getViewId      (  layerId ) );
     m_cTEncTop.setViewIndex                    ( vps.getViewIndex   (  layerId ) );
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
     Bool isDepth    = ( vps.getDepthId     ( layerId ) != 0  ) ;
     Bool isAuxDepth = ( vps.getAuxId       ( layerId ) ==  2 ) ; // TBD: define 2 as AUX_DEPTH
@@ -284,5 +284,7 @@
     m_cTEncTop.setIsAuxDepth               ( isAuxDepth ); 
     //====== Camera Parameters =========
-    m_cTEncTop.setCameraParameters             ( &m_cCameraData );     
+    m_cTEncTop.setCameraParameters         ( &m_cCameraData );     
+#endif
+#if NH_3D_VSO
     //====== VSO =========
     m_cTEncTop.setRenderModelParameters        ( &m_cRenModStrParser ); 
@@ -796,7 +798,7 @@
     {
 #if H_3D_VSO_EARLY_SKIP
-      m_cRendererModel.create( m_cRenModStrParser.getNumOfBaseViews(), m_cRenModStrParser.getNumOfModels(), m_iSourceWidth, m_uiMaxCUHeight , LOG2_DISP_PREC_LUT, 0, m_bVSOEarlySkip );
-#else
-      m_cRendererModel.create( m_cRenModStrParser.getNumOfBaseViews(), m_cRenModStrParser.getNumOfModels(), m_iSourceWidth, m_uiMaxCUHeight , LOG2_DISP_PREC_LUT, 0 );
+      m_cRendererModel.create( m_cRenModStrParser.getNumOfBaseViews(), m_cRenModStrParser.getNumOfModels(), m_iSourceWidth, m_uiMaxCUHeight , LOG2_DISP_PREC_LUT, 0, true, m_bVSOEarlySkip );
+#else
+      m_cRendererModel.create( m_cRenModStrParser.getNumOfBaseViews(), m_cRenModStrParser.getNumOfModels(), m_iSourceWidth, m_uiMaxCUHeight , LOG2_DISP_PREC_LUT, 0 , true);
 #endif
       for ( Int layer = 0; layer < m_numberOfLayers ; layer++ )
@@ -1036,5 +1038,5 @@
     for ( Int gopId=0; gopId < gopSize; gopId++ )
     {
-#if NH_3D_VSO
+#if NH_3D_VSO || NH_3D
       UInt iNextPoc = m_acTEncTopList[0] -> getFrameId( gopId );
       if ( iNextPoc < m_framesToBeEncoded )